@PROGRAM FOR COMPARING THE FIRST THREE ORDERS OF STOCHASTIC DOMINANCE
NON PARAMETRICALLY FOR NONINDEPENDENT RETURNS DATA@
OUTPUT FILE = SDNONRW.TXT;OUTPUT ON;
"RESULTS FOR WEIGHTED DISTRIBUTIONS (NON-INDEPENDENT SAMPLING)";
LOAD PANDA[]=AEDATF.TXT;
NR=ROWS(PANDA) / 8;
PAN=RESHAPE(PANDA,NR,8);
@SELECT COMPARISON YEARS@
WW = PAN[.,1]; YY= PAN[.,3];
WWPR=PAN[.,2];YYPR=PAN[.,4];
N79=ROWS(WW);N89=ROWS(YY);
N7989=N79+N89;
MXY=SUMC((WW .* WWPR) | (YY .* YYPR))/2;
X79=WW ./ MXY;
X79PR=WWPR;
X89=YY ./ MXY;
X89PR=YYPR;
XXX=WW~YY;XN=N79;
KQ=5;
KQL=KQ-1;
RWT=RNDN(KQL,1000);
PAT=0.0;
@    @
@SET UP RELATIVE FREQUENCY VECTOR@
           @    @
KQ1=KQ+1;KQKQ=KQ^2;
P=ZEROS(KQ1,1);
PQ=ZEROS(KQKQ,1);
IA=1;
DO WHILE IA<= KQ;
IB=IA+1;
P[IB]=IA/KQ;
IA=IA+1;
ENDO;
XXD=XXX[.,1] | XXX[.,2];
XXPR=(X79PR * (0.5)) | (X89PR * (0.5));
XXDD=XXD~XXPR~CUMSUMC(ONES(N7989,1));
XDDD=SORTC(XXDD,1);XXXDD=CUMSUMC(XDDD[.,2])~XDDD[.,3];
XYZ = SORTC(XXXDD,2) ;
X=XYZ[1:XN,1];
Y=XYZ[XN+1:2*XN,1];
IA=1;IL=1;CHIS=0.0;
DO WHILE IL <= KQ;
JL=1;
IU=IL+1;
DO WHILE JL <=KQ;
JU=JL+1;
E=((X .GT P[IL]) .AND (X .LE P[IU])) .AND ((Y .GT P[JL]) .AND (Y .LE P[JU]));
PQ[IA]=SUMC(E)/XN;CHIS=CHIS+((PQ[IA]-KQKQ^(-1))^2)*KQKQ;
IA=IA+1;
JL=JL+1;
ENDO;
IL=IL+1;
ENDO;
                       @      @
@SET UP MARGINALISING, AGGREGATING AND COVARIANCE MATRICES@
                       @      @
DA=ONES(KQ,KQ);
DL=LOWMAT(DA);
V=ONES(1,KQ);
D2=EYE(KQ*KQ);
DS=EYE(KQ);
D=(V .*. DL)-(DL .*. V);
OMEGA=D*(DIAGRV(D2,PQ)-PQ*PQ')*(D');
XXSORT=XDDD[.,1]~XYZ;
LET INDEX = 1;
DO WHILE INDEX <= KQ;
   BOB=MININDC(ABS(XXSORT[.,2]-P[INDEX,1]));
   DS[INDEX,INDEX]= XXSORT[BOB,1];
   INDEX = INDEX+1;
ENDO;
IA = 2;
DO WHILE IA <= KQ;
IB = 1;
DO WHILE IB < IA;IC=IB+1;
DS[IA,IB]=DS[IB,IB]+DS[IC,IC];
IB=IB+1;ENDO;
IA=IA+1;ENDO;
DSS=.5*DS;
         @     @
@CALCULATE TESTS STATISTICS@
         @     @
SD=ZEROS(KQ,3);
A11=D*PQ;A11S=SQRT(DIAG(OMEGA));
SD[1:KQ-1,1]=SQRT(XN)*A11[1:KQ-1,1]./A11S[1:KQ-1,1];
SD[.,2]=SQRT(XN)*DSS*D*PQ./SQRT(DIAG(DSS*OMEGA*DSS'));
SD[.,3]=SQRT(XN)*DSS*DSS*D*PQ./SQRT(DIAG(DSS*DSS*OMEGA*DSS'*DSS'));
@*******************************************************************@
@ This component calculates the omnibus inequality test a<b and b<a @
@*******************************************************************@
@                 calculate test statistics WTI                     @
@*******************************************************************@
IVAB=A11~(DSS*A11)~(DSS*DSS*A11);
IVBA=-IVAB;
DAB = IVAB .<= 0.0;DBA = IVBA .<= 0.0;
DTAB = IVAB .* DAB;DTBA = IVBA .* DBA;
IDS=INV(DSS);WTJ=ZEROS(3,2);
WTJ[1,1] = XN*DTAB[.,1]'*INVSWP(OMEGA)*DTAB[.,1];
WTJ[2,1] = XN*DTAB[.,2]'*IDS'*INVSWP(OMEGA)*IDS*DTAB[.,2];
WTJ[3,1] = XN*DTAB[.,3]'*IDS'*IDS'*INVSWP(OMEGA)*IDS*IDS*DTAB[.,3];
WTJ[1,2] = XN*DTBA[.,1]'*INVSWP(OMEGA)*DTBA[.,1];
WTJ[2,2] = XN*DTBA[.,2]'*IDS'*INVSWP(OMEGA)*IDS*DTBA[.,2];
WTJ[3,2] = XN*DTBA[.,3]'*IDS'*IDS'*INVSWP(OMEGA)*IDS*IDS*DTBA[.,3];
@*******************************************************************@
@             calculate chi squared weights WEI                     @
@     note the k-1 x 1000 std normal random matrix RWT has been     @
@     calculated outside of this segment to save computing time     @
@*******************************************************************@
PWTI=ZEROS(3,2);WEI=ZEROS(10,3);DFT=SEQA(0,1,10);
OM1=CHOL(OMEGA[1:KQL,1:KQL]);
OM2=DSS[1:KQL,1:KQL]*OM1';DS2=DSS*DSS;
OM3=DS2[1:KQL,1:KQL]*OM1';
RD= (OM1'*RWT) .<= 0.0;
WEI[.,1]=COUNTS(SUMC(RD),DFT)/1000;
RD=(OM2*RWT) .<= 0.0;
WEI[.,2]=COUNTS(SUMC(RD),DFT)/1000;
RD=(OM3*RWT) .<= 0.0;
WEI[.,3]=COUNTS(SUMC(RD),DFT)/1000;
CWAB=CDFCHIC(WTJ[.,1],DFT[2:10]');
CWBA=CDFCHIC(WTJ[.,2],DFT[2:10]');
IAM=1;
DO WHILE IAM <=3;
PWTI[IAM,1]=WEI[2:10,IAM]'*REV(CWAB[IAM,.]');
PWTI[IAM,2]=WEI[2:10,IAM]'*REV(CWBA[IAM,.]');
IAM = IAM + 1;
ENDO;
XN*CHIS;SD;
WTJ;PWTI;
END;
